package eastsun.jgvm.module;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

/**
 * װһִеlav,ڲάһļָ
 * @author Eastsun
 */
public abstract class LavApp {

    private byte[] appData;
    private int offset;

    /**
     * ͨһһLavApp
     * @param in һ
     * @return һLavApp
     * @throws java.lang.IllegalArgumentException IOݸʽȷ
     */
    public static LavApp createLavApp(InputStream in) throws IllegalArgumentException {
        return new DefaultLavApp(in);
    }

    /**
     * ͨһlavһLavApp<p>
     * ע,LavAppڲʹõľǸ,ഴܴⲿ޸
     * @param data
     * @throws java.lang.IllegalArgumentException
     */
    protected LavApp(byte[] data) throws IllegalArgumentException {
        this.appData = data;
        verifyData();
    }

    /**
     * lavݴС(ֽ)
     * @return size lavݵܴС,ļͷ
     */
    public final int size() {
        return appData.length;
    }

    /**
     * pointerȡһֽ,ʹpointerһ<p>
     * ע,ﷵֵchar,Ӧlavchar,Ϊlavchar޷ŵ.
     */
    public final char getChar() {
        return (char) (appData[offset++] & 0xff);
    }

    /**
     * appжȡֽ,Ӧlavеint
     * @return int
     */
    public final short getInt() {
        short s;
        s = (short) (appData[offset++] & 0xff);
        s |= (appData[offset++] & 0xff) << 8;
        return s;
    }

    /**
     * appжȡֽ(޷),Ӧlavļָ
     */
    public final int getAddr() {
        int addr;
        addr = appData[offset++] & 0xff;
        addr |= (appData[offset++] & 0xff) << 8;
        addr |= (appData[offset++] & 0xff) << 16;
        return addr;
    }

    /**
     * appжȡֽ,Ӧlavеlong
     */
    public final int getLong() {
        int i;
        i = appData[offset++] & 0xff;
        i |= (appData[offset++] & 0xff) << 8;
        i |= (appData[offset++] & 0xff) << 16;
        i |= (appData[offset++] & 0xff) << 24;
        return i;
    }

    /**
     * õǰƫ
     * @return pointer ´ζȡʱλ
     */
    public final int getOffset() {
        return offset;
    }

    /** öȡƫ
     * @param pos ƫ,´ζȡʱʼλ
     */
    public final void setOffset(int pos) {
        offset = pos;
    }

    private static class DefaultLavApp extends LavApp {

        public DefaultLavApp(InputStream in) {
            super(getDataByInputStream(in));
        }

        /**
         * 2008.3.5<p>
         * bug fixed<p>
         * J2MEĳЩInputStreamavailableǷ0
         */
        private static byte[] getDataByInputStream(InputStream in) {
            ByteArrayOutputStream bos = new ByteArrayOutputStream();
            byte[] tmpBuffer = new byte[512];
            try {
                int length;
                while ((length = in.read(tmpBuffer)) != -1) {
                    bos.write(tmpBuffer, 0, length);
                }
            } catch (IOException ex) {
                throw new IllegalArgumentException(ex.getMessage());
            } finally {
                try {
                    in.close();
                } catch (IOException ex) {
                //do nothing
                }
            }
            return bos.toByteArray();
        }
    }

    /**
     * ݸʽӦ
     * @param data һlavApp
     * @throws java.lang.IllegalArgumentException ȷlavaʽ
     */
    private void verifyData() throws IllegalArgumentException {
        if (appData.length <= 16) {
            throw new IllegalArgumentException("ЧLAVļ!");
        }
        if (appData[0] != 0x4c || appData[1] != 0x41 || appData[2] != 0x56) {
            throw new IllegalArgumentException("ЧLAVļ!");
        }
        offset = 16;
    }
}
