package eastsun.jgvm.module;

import eastsun.jgvm.module.event.Area;
import eastsun.jgvm.module.event.ScreenChangeListener;
import eastsun.jgvm.module.ram.RelativeRam;

/**
 * Ļģ,ģ鱣Դ漰ʵĿѡʵ
 * @version 0.7 2007/1/21  ޸ⲿõĻݵĽӿ<p>
 *               2008/2/24  ٴ޸ĻĻݵĽӿ,ҪĿŻˢٶ
 * @author Eastsun
 */
public abstract class ScreenModel {

    /**
     * Ļ
     */
    public static final int WIDTH = 160;
    /**
     * Ļ߶
     */
    public static final int HEIGHT = 80;

    /**
     * һScreenModelʵ
     */
    public static ScreenModel newScreenModel() {
        return new ScreenModelImp();
    }
    private ScreenChangeListener[] lis;

    protected ScreenModel() {
        lis = new ScreenChangeListener[0];
    }

    /**
     * ΪScreenӼ,ScreenGraph״̬仯ʱ仯ʱ¼
     * @param listener ¼
     */
    public final void addScreenChangeListener(ScreenChangeListener listener) {
        ScreenChangeListener[] oldValue = lis;
        lis = new ScreenChangeListener[oldValue.length + 1];
        int index = 0;
        for (; index < oldValue.length; index++) {
            lis[index] = oldValue[index];
        }
        lis[index] = listener;
    }

    /**
     * ֪ͨĻ
     */
    public final void fireScreenChanged() {
        for (int index = 0; index < lis.length; index++) {
            lis[index].screenChanged(this, getChangedArea());
        }
        refreshArea();
    }

    /**
     * õĻĿ
     * @return width
     */
    public final int getWidth() {
        return WIDTH;
    }

    /**
     * õĻĸ߶
     * @return height
     */
    public final int getHeight() {
        return HEIGHT;
    }

    /**
     * ڱʾڰ׵ɫRGBֵ
     * @param black 
     * @param white 
     */
    public abstract void setColor(int black, int white);

    /**
     * õĻrgb<p>
     * Լ:<p>
     *     1. bufferĳӦСgetWidth()*getHeight()*rate*rate<p>
     *     2. bufferݵʱὫbufferһ(getWidth()*rate)*(getHeight()*rate)(ֻûת,ת)<p>
     *        Ȼ󽫷仯䵽bufferӦλ,Ǵ鿪ʼ,Ҳһ<p>
     *  2008.2.24޸
     * @param buffer ڱĻrgbݵint,䳤ӦС offset+rate*getWidth()*getHeight()
     * @param area   ҪĵͼĻķΧ
     * @param rate   ͼķŴ
     * @param circ   Ϊ0,1,2,3.ֱʾת,ʱת90,180,270
     * @return buffer
     */
    public abstract int[] getRGB(int[] buffer, Area area, int rate, int circ);

    /**
     * ǷԴԼԴ滺Ram
     * @return ҽĻСΪ160*80ʱtrue
     */
    public abstract boolean hasRelativeRam();

    /**
     * õĻԴRam,Խ䰲װRamManager,ʹLAVAֱܹӷԴ
     * @return ram õRam,RamScreenݱͬ仯
     * @throws IllegalStateException hasRelativeRam()false
     * @see #hasRelativeRam()
     * @see RamManager#install(Ram)
     */
    public abstract RelativeRam getGraphRam();

    /**
     * õĻRam,Խ䰲װRamManager,ʹLAVAֱܹӷĻ
     * @return ram õRam,RamScreenݱͬ仯
     * @throws IllegalStateException hasRelativeRam()false
     * @see #hasRelativeRam()
     * @see RamManager#install(Ram)
     */
    public abstract RelativeRam getBufferRam();

    /**
     * Ļͼӿ
     * @return render
     */
    public abstract Renderable getRender();

    /**
     * 仯Χarea,ʹ¼¼仯Χ<p>
     * ⼸changedAreaķֻӦJGVMڲʹ
     * @see #getChangedArea()
     * @see #getRGB(int[],Area,int,int)
     */
    abstract void refreshArea();

    /**
     * õıĻΧ<p>
     * 2008.2.24
     * @return area
     */
    abstract Area getChangedArea();

    /**
     * ıadd
     * @param add µĸĶ
     */
    abstract void addToChangedArea(Area add);
}
