package eastsun.jgvm.module.io;

import eastsun.jgvm.module.ram.Setable;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.util.Enumeration;

/**
 * װƴ뷨Ϣ
 * @author Eastsun
 * @version 2008-3-17
 */
public final class SpellInfo {

    private SpellInfo() {
    }

    /**
     * õSpellNodeö,аƴֵ˳еcountSpellNode
     */
    public static Enumeration list() {
        return new SpellNodeEnum();
    }

    /**
     * õͬƴĿ
     * @return count
     */
    public static int count() {
        return SPELL_NODES.length;
    }
    private static final String SPELL_DATA = "/eastsun/jgvm/module/io/res/spell.dat";
    private static final SpellNode[] SPELL_NODES;
    

    static {
        //װƴ
        //ݸʽ:
        //һֽ0xABʾ汾ΪA.B
        //ڶ,ֽڱʾܹжٸƴ
        //Ϊƴ,ÿƴݵĸʽΪ"Ӧ(һֽ) ƴַ |"
        //Ǻ,ƴֵĴ˳
    	
    	android.content.Context con = eastsun.jgvm.plaf.android.MainView.getCurrentView().getContext();
    	InputStream in = con.getResources().openRawResource(eastsun.jgvm.plaf.android.R.raw.spell);
        //InputStream in = SpellInfo.class.getResourceAsStream(SPELL_DATA);
        SpellNode[] tmp = null;
        try {
            int version = in.read();
            if (version != 0x10) {
                throw new IllegalStateException("ʺϵݰ汾:" + Integer.toHexString(version));
            }
            int count = in.read();
            count = count + in.read() * 256;
            tmp = new SpellNode[count];
            byte[] buffer = new byte[20];
            for (int index = 0; index < count; index++) {
                int size = in.read();
                int n = 0, b;
                while ((b = in.read()) != '|') {
                    buffer[n++] = (byte) b;
                }
                String spell = new String(buffer, 0, n);
                tmp[index] = new SpellNode(spell, size);
            }
            for (int index = 0; index < count; index++) {
                SpellNode node = tmp[index];
                byte[] data = new byte[2 * node.size];
                in.read(data);
                node.setData(data);
            }
        } catch (IOException ex) {
            System.exit(-1);
        } finally {
            try {
                in.close();
            } catch (Exception ex) {
                //do nothing
            }
        }
        SPELL_NODES = tmp;
    }

    private static class SpellNodeEnum implements Enumeration {

        private int index = 0;

        public boolean hasMoreElements() {
            return index < SPELL_NODES.length;
        }

        public Object nextElement() {
            return SPELL_NODES[index++];
        }
    }

    public static class SpellNode {

        private String spell;
        private byte[] data;
        private int size;

        /**
         * װƴϢ
         * @param spell ƴ
         * @param data spellӦĺֵgb2312ɵ,ڲֱʹ
         */
        SpellNode(String spell, int size) {
            this.spell = spell;
            this.size = size;
        }

        /**
         * õnodeƴַ
         */
        public String spell() {
            return spell;
        }

        /**
         * ƴӦָ
         */
        public int size() {
            return size;
        }

        /**
         * ȡøƴidʼlenֵgb2312
         * @param dst ڱ
         * @param id       ʼĺֱ,0ʼ
         * @param len     ȡĺָ
         * @return           ʵʻȡĺָ
         */
        public int getGB(Setable dst, int offset, int id, int len) {
            id <<= 1;
            len <<= 1;
            int index = 0;
            while (index < len && id + index < data.length) {
                dst.setByte(offset + index, data[id + index]);
                index++;
                dst.setByte(offset + index, data[id + index]);
                index++;
            }
            return index >>> 1;
        }

        public String toString() {
            String gbStr = null;
            try {
                gbStr = new String(data, 0, data.length, "gb2312");
            } catch (UnsupportedEncodingException ex) {
                gbStr ="Don't Unsupport GB2312";
            }
            return spell + ": " + gbStr;
        }

        /**
         *  ønodeĺ,ڲֱʹøbyte
         */
        void setData(byte[] data) {
            if (data.length != size * 2) {
                throw new IllegalStateException();
            }
            this.data = data;
        }
    }
}
